#ifndef _LC7980_H
#define _LC7980_H


#define LCD_DATA_DDR DDRA
#define LCD_DATA_PORT PORTA

#define LCD_CTRL_DDR DDRB
#define LCD_CTRL_PORT PORTB
#define LCD_E (1<<PB0)
#define LCD_RS (1<<PB1)
#define LCD_RW (1<<PB2)

#define LCD_DISPLAY_ON 32
#define LCD_DISPLAY_OFF 0
#define LCD_BLINK_16 64
#define LCD_BLINK_32 0
#define LCD_TRANSFER_EO 128
#define LCD_TRANSFER_BIT 0
#define LCD_BLINK_ON 8
#define LCD_BLINK_OFF 0
#define LCD_CURSOR_ON 4
#define LCD_CURSOR_OFF 0
#define LCD_MODE_GRAPHIC 2
#define LCD_MODE_TEXT 0
#define LCD_CG_EXT 1
#define LCD_CG_INT 0


#define LCD_SET_CHAR_PITCH 1
#define LCD_SET_CHAR_NUM 2
#define LCD_SET_TIME_DIV 3
#define LCD_SET_START_LO 8
#define LCD_SET_START_HI 9
#define LCD_SET_CURS_LO 10
#define LCD_SET_CURS_HI 11
#define LCD_WRITE_DISPLAY_DATA 12


extern void LCD_Strobe();
extern void LCD_WriteCommand(uint8_t);
extern void LCD_WriteData(uint8_t);
extern void LCD_SetCursor();
extern void LCD_Init();
extern void LCD_SetCharSize(uint8_t, uint8_t);
extern void LCD_SetDisplaySize(uint8_t, uint8_t);
extern void LCD_SetDisplayStart(uint16_t);
extern void LCD_SetCursorAddr(uint16_t);
extern void LCD_WriteDisplayData();
extern void LCD_ClearHome();
extern void LCD_PutC(char);
extern void LCD_PutS(char *);
extern void LCD_PutDHex(uint16_t);
extern void LCD_PutHex(uint8_t);
extern void LCD_PutNum(uint16_t);

extern uint8_t lcd_cursor;

#endif
