#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <avr/eeprom.h>

#include "UART.h"
#include "LC7980.h"
#include "vbus.h"

#define nop()	asm("nop")

ISR (USART_RX) {
	uint8_t c = UDR; //Character einlesen
	
	Vbus_ProcessChar(c);
}


void VBus_Show_Values() {
	UART_PutS("---\r\n");
	uint8_t i;
	uint16_t tmp;
	for(i = 0; i < 13; i++) {
		UART_PutS("\r\nTemp ");
		UART_PutNum(i);
		UART_PutS(":\t");
		tmp = vbus_outdata.temp[i];
		UART_PutNum(tmp / 10);
		UART_PutC('.');
		UART_PutC(tmp % 10 + 48);
		UART_PutS("C");
	}

	UART_PutS("\r\nUnbekannt1: ");
	UART_PutHex(vbus_outdata.unknown1);

	UART_PutS("\r\nEinstrahlung: ");
	UART_PutNum(vbus_outdata.irradiation);

	UART_PutS("\r\nSensorbruchmaske: ");
	UART_PutDHex(vbus_outdata.sensorbroke);
	UART_PutS("\r\nSensorkurzschlussmaske: ");
	UART_PutDHex(vbus_outdata.sensorshort);
	UART_PutS("\r\nSensorbenutzungsmaske: ");
	UART_PutDHex(vbus_outdata.sensorusage);

	for(i = 0; i < 9; i++) {
		UART_PutS("\r\nPumpe ");
		UART_PutNum(i);
		UART_PutS(": ");
		UART_PutNum(vbus_outdata.pump[i]);
		UART_PutS("%");
	}
	
	UART_PutS("\r\nUnbekannt2: ");
	for(i = 0; i < 4; i++) {
		UART_PutHex(vbus_outdata.unknown2[i]);
		UART_PutC(' ');
	}
		

	UART_PutS("\r\nRelaisbenutzungsmaske: ");
	UART_PutDHex(vbus_outdata.relaisusage);

	UART_PutS("\r\nFehlermaske: ");
	UART_PutDHex(vbus_outdata.errors);

	UART_PutS("\r\nWarnungsmaske: ");
	UART_PutDHex(vbus_outdata.warnings);

	UART_PutS("\r\nVersion Controller: ");
	UART_PutDHex(vbus_outdata.controllerversion);

	UART_PutS("\r\nZeit: ");
	UART_PutNum(vbus_outdata.time / 60);
	UART_PutC(':');
	UART_PutNum(vbus_outdata.time % 60);

	UART_PutS("\r\nUnbekannt3: ");
	for(i = 0; i < 4; i++) {
		UART_PutHex(vbus_outdata.unknown3[i]);
		UART_PutC(' ');
	}
}

int main() {
	LCD_Init();


	lcd_cursor = 200;

	UART_Init();
	sei();
	
	vbus_outdata.update = 1;

	while(1) {
		if(vbus_outdata.valid == 1) {
			vbus_outdata.valid = 0;
			VBus_Show_Values();
			vbus_outdata.update = 1;
		}
	}
}
